#include <iostream>
#include <vector>
#include <list>

using namespace std;

template <typename Kol> void ispis(Kol k){
	//ovo typename pre Kol negde (npr. na DevCPP 5.11)
	// treba, a na nekim kompajlerima (VS2010) ne treba (ne mora)
	for(typename Kol::iterator it=k.begin(); it!=k.end(); it++){
		// it je pokazivac na mem. lokaciju sa sadrzajem
		// tako da da bismo dobili sadrzaj moramo da dereferenciramo
		// pokazivacku promenljivu
		cout<<(*it)<<endl;
	}
}

// drugi tip T nam je bitan kako bismo imali promenljivu x
// odgovarajuceg tipa
template <typename Kol, typename T> void ucitaj(Kol &k){
	cout<<"Broj elemenata: "<<endl;
	int n;
	T x;
	cin>>n;
	for(int i=0; i<n; i++){
		cin>>x;
		k.push_back(x);
	}
}

int main(int argc, char** argv) {
	// kreiranje vektora sa podrazumevanim
	// incijalnim kapacitetom
	vector<int> v1;
	list<float> l1; 
	
	// efikasna operacija kod vektora je dodavanje
	// na kraj
	v1.push_back(5);
	v1.push_back(7);
	v1.push_back(9);
	v1.push_back(9);
	v1.push_back(9);
	
	//koliko je el. trenutno ubaceno 
	cout<<v1.size()<<" elemenata"<<endl;
	cout<<v1.capacity()<<" trenutni kapacitet"<<endl;
	
	// niz bazirano iteriranje
	for(int i=0; i<v1.size(); i++){
		cout<<v1[i]<<endl; // v1.at(i)
	}
	// inicijalna vrednost iteratorske promenljive
	// ce biti pokazivac na pocetak vektora (v1.begin())
	for(vector<int>::iterator it=v1.begin(); it!=v1.end(); it++){
		// it je pokazivac na mem. lokaciju sa sadrzajem
		// tako da da bismo dobili sadrzaj moramo da dereferenciramo
		// pokazivacku promenljivu
		cout<<(*it)<<endl;
	}
	// mora razmak da se ubaci na komp. DevCPP 5.11
	ispis< vector<int> >(v1);
	// a moze i bez gen. tipa pa se on implicitno odredjuje
	//ispis(v1);
	ucitaj< list<float>, float >(l1);
	ispis(l1);
	
	return 0;
}
